# -----------------------------------------------------------------------------------
#
#  Depenancies
#   - taglib development files
#   - X11 lib (needed for Fedora)
# -----------------------------------------------------------------------------------
CONFIG += release
TEMPLATE = app
VERSION = 0.0.52b
DEFINES += APP_VERSION="$$VERSION"
# Faire un make clean si modif du parametre TEST_FLAG
#DEFINES += TEST_FLAG
INCLUDEPATH += /usr/include/phonon
INCLUDEPATH += /usr/include/taglib
DESTDIR = build/target/
OBJECTS_DIR = build/obj/
MOC_DIR = build/moc/
RCC_DIR = build/rcc/
TARGET = YaRock
#LIBS += -ltag 
# ltag => OK under Ubuntu/Kunbuntu 
# add X11 lib for qxtglobalshortcut_x11 build (under Fedora)
LIBS += -ltag -lX11

QT += network phonon sql xml dbus

include(src3party/qtsingleapplication/qtsingleapplication.pri)
include(src3party/libechonest/libechonest.pri)
include(src3party/qxt/qxt.pri)

DEPENDPATH += . \
              src \
              translation \
              src/CentralWidget \
              src/CollectionModel \
              src/CollectionView \
              src/ContextView \
              src/Database \
              src/DashBoard \
              src/Dbus \
              src/FileViewer \
              src/GraphicViewWidget \
              src/Histo \
              src/MediaItem \
              src/NowPlaying \
              src/Player \
              src/Playlist \
              src/RadioModel \
              src/RadioView \
              src/ScreenMode \
              src/Scrobbler \
              src/SmartPlaylist \
              src/UserSettings \
              src/Web \
              src/Widget \
              src3party/qtsingleapplication
              
INCLUDEPATH += . \
               src3party/qtsingleapplication \
               src \
               src/Player \
               src/Playlist \
               src/MediaItem \
               src/Widget \
               src/NowPlaying \
               src/GraphicViewWidget \
               src/CollectionView \
               src/CollectionModel \
               src/RadioView \
               src/RadioModel \
               src/ContextView \
               src/CentralWidget \
               src/FileViewer \
               src/Web \
               src/ScreenMode \
               src/Scrobbler \
               src/SmartPlaylist \
               src/Database \
               src/Histo \
               src/UserSettings

# Input
HEADERS += src/constants.h \
           src/global.h \
           src/mainwindow.h \
           src/qpixmapfilter.h \
           src/threadpool.h \
           src/utilities.h \
           src/viewmode.h \
           src/CentralWidget/centraltoolbar.h \
           src/CentralWidget/centralwidget.h \
           src/CentralWidget/menuitem.h \
           src/CentralWidget/menumodel.h \
           src/CentralWidget/menuview.h \
           src/CentralWidget/navigatorbar.h \
           src/CollectionModel/collectionmodel.h \
           src/CollectionModel/collectionpopulator.h \
           src/CollectionModel/histomodel.h \
           src/CollectionModel/plsfilemodel.h \
           src/CollectionModel/plsfilepopulator.h \
           src/CollectionView/collectionscene.h \
           src/CollectionView/graphicitem.h \
           src/CollectionView/userchangedialog.h \
           src/CollectionView/virtualplaylist.h \
           src/ContextView/contextgraphicitem.h \
           src/ContextView/contextscene.h \
           src/ContextView/infodownloader.h \
           src/ContextView/lyricseditor.h \
           src/ContextView/ultimatelyricsprovider.h\
           src/ContextView/ultimatelyricsreader.h \
           src/Database/database.h \
           src/Database/databasebuilder.h \
           src/Database/databasemanager.h \
           src/DashBoard/dashboard.h \
           src/Dbus/dbusnotification.h \
           src/FileViewer/fileviewer.h \
           src/GraphicViewWidget/graphicviewwidget.h \
           src/Histo/histomanager.h \
           src/MediaItem/mediaitem.h \
           src/MediaItem/mediamimedata.h \
           src/MediaItem/mediaplaylist.h \
           src/NowPlaying/nowplayingview.h \
           src/Player/player.h \
           src/Player/inforesolver.h \
           src/Playlist/playlistdbwriter.h \
           src/Playlist/playlistmodel.h \
           src/Playlist/playlistpopulator.h \
           src/Playlist/playlistview.h \
           src/Playlist/playlistwidget.h \
           src/Playlist/playlistwriter.h \
           src/RadioModel/icecastmanager.h \
           src/RadioModel/shoutcastmanager.h \
           src/RadioModel/streammodel.h \
           src/RadioModel/xspfstreamfile.h \
           src/RadioView/radioscene.h \
           src/ScreenMode/miniwidget.h \
           src/ScreenMode/nowplaying.h \
           src/Scrobbler/scrobblerlastfm.h \
           src/Scrobbler/scrobblermanager.h \
           src/SmartPlaylist/smartplaylist.h \
           src/UserSettings/settingsdialog.h \
           src/UserSettings/settingspages.h \
           src/UserSettings/shortcutdialog.h \
           src/Web/coversearch.h \
           src/Web/coverthread.h \
           src/Web/networkaccess.h \
           src/Widget/audiocontrols.h \
           src/Widget/customsplitter.h \
           src/Widget/equalizer.h \
           src/Widget/equalizerslider.h \
           src/Widget/playertoolbar.h \
           src/Widget/searchfield.h \
           src/Widget/seekslider.h \
           src/Widget/spacer.h \
           src/Widget/splittercollapser.h \
           src/Widget/statusbar.h 

SRCMOC += build/moc/moc_statusbar.cpp

SOURCES += src/main.cpp \
           src/mainwindow.cpp \
           src/qpixmapfilter.cpp \
           src/threadpool.cpp \
           src/utilities.cpp \
           src/viewmode.cpp \
           src/CentralWidget/centraltoolbar.cpp \
           src/CentralWidget/centralwidget.cpp \
           src/CentralWidget/menuitem.cpp \
           src/CentralWidget/menumodel.cpp \
           src/CentralWidget/menuview.cpp \
           src/CentralWidget/navigatorbar.cpp \
           src/CollectionModel/collectionmodel.cpp \
           src/CollectionModel/collectionpopulator.cpp \
           src/CollectionModel/histomodel.cpp \
           src/CollectionModel/plsfilemodel.cpp \
           src/CollectionModel/plsfilepopulator.cpp \
           src/CollectionView/collectionscene.cpp \
           src/CollectionView/graphicitem.cpp \
           src/CollectionView/userchangedialog.cpp \
           src/CollectionView/virtualplaylist.cpp \
           src/ContextView/contextgraphicitem.cpp \
           src/ContextView/contextscene.cpp \
           src/ContextView/infodownloader.cpp \
           src/ContextView/lyricseditor.cpp \
           src/ContextView/ultimatelyricsprovider.cpp \
           src/ContextView/ultimatelyricsreader.cpp \
           src/Database/database.cpp \
           src/Database/databasebuilder.cpp \
           src/Database/databasemanager.cpp \
           src/DashBoard/dashboard.cpp \
           src/Dbus/dbusnotification.cpp \
           src/FileViewer/fileviewer.cpp \
           src/GraphicViewWidget/graphicviewwidget.cpp \
           src/Histo/histomanager.cpp \
           src/MediaItem/mediaitem.cpp \
           src/MediaItem/mediamimedata.cpp \
           src/MediaItem/mediaplaylist.cpp \           
           src/NowPlaying/nowplayingview.cpp \
           src/Player/player.cpp \
           src/Player/inforesolver.cpp \
           src/Playlist/playlistdbwriter.cpp \
           src/Playlist/playlistmodel.cpp \
           src/Playlist/playlistpopulator.cpp \
           src/Playlist/playlistview.cpp \
           src/Playlist/playlistwidget.cpp \
           src/Playlist/playlistwriter.cpp \
           src/RadioModel/icecastmanager.cpp \
           src/RadioModel/shoutcastmanager.cpp \
           src/RadioModel/streammodel.cpp \
           src/RadioModel/xspfstreamfile.cpp \
           src/RadioView/radioscene.cpp \
           src/ScreenMode/miniwidget.cpp \
           src/ScreenMode/nowplaying.cpp \
           src/Scrobbler/scrobblerlastfm.cpp \
           src/Scrobbler/scrobblermanager.cpp \
           src/SmartPlaylist/smartplaylist.cpp \
           src/UserSettings/settingsdialog.cpp \
           src/UserSettings/settingspages.cpp \
           src/UserSettings/shortcutdialog.cpp \
           src/Web/coversearch.cpp \
           src/Web/coverthread.cpp \
           src/Web/networkaccess.cpp \
           src/Widget/audiocontrols.cpp \
           src/Widget/customsplitter.cpp \
           src/Widget/equalizer.cpp \
           src/Widget/equalizerslider.cpp \
           src/Widget/playertoolbar.cpp \
           src/Widget/searchfield.cpp \
           src/Widget/seekslider.cpp \
           src/Widget/spacer.cpp \
           src/Widget/splittercollapser.cpp \
           src/Widget/statusbar.cpp 


# Resources -----------------------------------
RESOURCES += YaRock.qrc
RESOURCES += translation.qrc

# Translation ---------------------------------
TRANSLATIONS    += translation/yarock_fr.ts
TRANSLATIONS    += translation/yarock_cs.ts
TRANSLATIONS    += translation/yarock_es.ts
TRANSLATIONS    += translation/yarock_ro.ts

CODECFORTR = UTF-8
CODECFORSRC = UTF-8

# Deployment ----------------------------------
unix {
  isEmpty(PREFIX):PREFIX = /usr/local
  SHAREDIR   = $$PREFIX/share
  BINDIR     = $$PREFIX/bin
  LOCALEDIR =  $$SHAREDIR/locale/YaRock
  PKGDATADIR = $$SHAREDIR/YaRock

  DEFINES += LOCALEDIR=\\\"$$LOCALEDIR\\\"
  DEFINES += PKGDATADIR=\\\"$$PKGDATADIR\\\"

  INSTALLS += target
  target.path = $$BINDIR

  INSTALLS += desktop \
              translations \
              radio   \
              icon16  \
              icon32  \
              icon48  \
              icon64  \
              icon128 
  translations.path = $$LOCALEDIR
  translations.files += translation/yarock_fr.qm
  translations.files += translation/yarock_cs.qm
  translations.files += translation/yarock_es.qm
  translations.files += translation/yarock_ro.qm
  desktop.path = $$SHAREDIR/applications
  desktop.files += data/yarock.desktop
  radio.path = $$PKGDATADIR
  icon16.path = $$SHAREDIR/icons/hicolor/16x16/apps
  icon16.files += icon/16x16/yarock.png
  icon32.path = $$SHAREDIR/icons/hicolor/32x32/apps
  icon32.files += icon/32x32/yarock.png
  icon48.path = $$SHAREDIR/icons/hicolor/48x48/apps
  icon48.files += icon/48x48/yarock.png
  icon64.path = $$SHAREDIR/icons/hicolor/64x64/apps
  icon64.files += icon/64x64/yarock.png
  icon128.path = $$SHAREDIR/icons/hicolor/128x128/apps
  icon128.files += icon/128x128/yarock.png
}


