/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef _CENTRAL_TOOLBAR_H_
#define _CENTRAL_TOOLBAR_H_

#include "Widget/searchfield.h"
#include "CentralWidget/menumodel.h"
#include "CentralWidget/navigatorbar.h"
#include "viewmode.h"

#include <QToolBar>
#include <QList>


/*******************************************************************************
    CentralToolBar
*******************************************************************************/
class CentralToolBar : public QToolBar
{
Q_OBJECT
    static CentralToolBar* INSTANCE;
  public:
    CentralToolBar(QWidget *parent);
    static CentralToolBar* instance() { return INSTANCE; } 
    void updateMode(MAIN::ViewMode mode);
    void updateCurrentIndex(const QModelIndex &idx);
    
  private slots:
     void sendSearch();
     void activePrev();
     void activeNext();

  signals:
    void searchActivated(QString);
    void prevNextActivated(QModelIndex, QString);
    
  private:
    MenuModel          *_menuModel;
    SearchField        *_searchField;
    NavigatorBar       *_navigatorBar;
    
    //! Prev/Newt History navigation
    int                _currentBrowserIdx;
    QList<QModelIndex> _browserList;
    QStringList        _searchList;
};

#endif // _CENTRAL_TOOLBAR_H_
