/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _CENTRAL_WIDGET_H_
#define _CENTRAL_WIDGET_H_

#include "CentralWidget/centraltoolbar.h"
#include "CentralWidget/menuview.h"
#include "GraphicViewWidget/graphicviewwidget.h"
#include "FileViewer/fileviewer.h"         
#include "NowPlaying/nowplayingview.h"
#include "Playlist/playlistwidget.h"

#include "Widget/customsplitter.h"
#include "viewmode.h"

#include <QtGui>

/*******************************************************************************
    CentralWidget
*******************************************************************************/
class CentralWidget : public QWidget
{
Q_OBJECT
  public: 
    CentralWidget(QWidget *parent, 
               CentralToolBar     *centralToolBar,
               MenuView           *menuView,
               NowPlayingView     *nowPlayingView,
               PlaylistWidget     *playlistWidget,
               GraphicViewWidget  *graphicViewWidget,
               FileViewer         *fileViewer
               );
    
    ~CentralWidget();
        
  private :
    MenuView            *_menuView;
    CentralToolBar      *_centraltoolbar;
    NowPlayingView      *_nowplayingview;
    PlaylistWidget      *_playlistwidget;
    
    GraphicViewWidget   *_graphicviewwidget;
    FileViewer          *_fileViewer;
  
    QStackedWidget      *_stackedCentralWidget;
    QFrame              *_rightWidget;
    QFrame              *_leftWidget;
    CustomSplitter      *_viewsSplitter;
        
    MAIN::ViewMode       _mainMode;
    
  private slots:
    void createGui();
    void restoreState();
    void showPlaylist();
    void showMenu();
    
    void updateMode(MAIN::ViewMode mode);
    //void prevNextItemActivated(QModelIndex index);
    void prevNextItemActivated(QModelIndex index, QString search);
    void modelItemActivated(QModelIndex index);
    void updateMenu(QModelIndex index, bool newActivation);
};


#endif // _CENTRAL_WIDGET_H_
