/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef _NAVIGATOR_BAR_H_
#define _NAVIGATOR_BAR_H_

#include <QWidget>
#include <QToolBar>
#include <QPushButton>
#include <QIcon>
#include <QString>
#include <QEvent>
#include <QMouseEvent>
#include <QMenu>
#include <QTimer>


/*******************************************************************************
    NavigatorBar
*******************************************************************************/
class MenuModel;
class NavigatorItemButton;

class NavigatorBar : public QToolBar 
{
Q_OBJECT
  public:
    NavigatorBar(QWidget *parent = 0);
    virtual void setModel(MenuModel * m);

    QSize sizeHint() const;
    
  private:
    MenuModel                   *_model;
    QList<NavigatorItemButton*> _listButton;
    
 /* protected:
    void enterEvent(QEvent *e);
    void leaveEvent(QEvent *e);
    void mouseMoveEvent ( QMouseEvent * e );*/
    
  public slots:
    void hideMenu();
    
  private slots:
    void updateEntry();
};


/*******************************************************************************
    NavigatorItemButton
*******************************************************************************/
class NavigatorItemMenu;

class NavigatorItemButton : public QPushButton
{
Q_OBJECT
  public:
    NavigatorItemButton( const QIcon & icon, const QString & text, QWidget *parent );
    QSize sizeHint() const;
    NavigatorItemMenu        *_menu;
    
  protected:
    void paintEvent(QPaintEvent* event);
    void enterEvent(QEvent *e);
    void leaveEvent(QEvent *e);
  
  private:
    QTimer      *_timer;
    QFont       _font;
  
  signals :
    void enterButton();
};


/*******************************************************************************
    NavigatorItemMenu
*******************************************************************************/
class NavigatorItemMenu : public QMenu
{
Q_OBJECT
  public:
    NavigatorItemMenu();
    bool        isUnderMouse;
    
  protected:
    void enterEvent(QEvent *e);
    void leaveEvent(QEvent *e);
    
  public slots:
    void checkForHide();    
};


#endif // _NAVIGATOR_BAR_H_
