/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _HISTOMODEL_H_
#define _HISTOMODEL_H_


#include <QList>
#include <QString>
#include <QObject>
#include <QMutex>

class MediaItem;


/*******************************************************************************
    HistoModel
*******************************************************************************/
class HistoModel  : public QObject
{
Q_OBJECT
    static HistoModel*   INSTANCE;

  public:
    HistoModel(QObject *parent);
    static HistoModel* instance() { return INSTANCE; }    
     
    void updateModel();
    int itemCount() {return _listMediaItem.size();}
    MediaItem* getItem(int row);

    //! playing status method
    void     stopPlayingItem();
    void     updatePlayingItem(const QString& url);

    //! broken status method
    void     updateBrokenItem(const QString& url);
    
    //! filtering method
    QString               _filterPattern;
    bool isItemFiltered(const int row);
    
    void clear();

  signals:
    void signalPlayingStatusChanged();
    
  public:
    bool                  modelUpdated;

  private:
    QList<MediaItem*>   _listMediaItem;
    MediaItem*          _activeItem;
    QMutex              _mutex;
};

#endif // _HISTOMODEL_H_ 
