/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _PLSFILE_MODEL_H_
#define _PLSFILE_MODEL_H_

#include <QVariant>
#include <QString>
#include <QStringList>
#include <QObject>


/*******************************************************************************
    PlsFileModel
*******************************************************************************/
class MediaItem;
class PlsFileModel : public QObject
{
Q_OBJECT
     static PlsFileModel*  INSTANCE;

  public:
     PlsFileModel(QObject *parent = 0);
     ~PlsFileModel();
     static PlsFileModel* instance() { return INSTANCE; }    
    
     //! custom method
     MediaItem* rootItem();
     MediaItem* addChild(MediaItem* parent);
     MediaItem* getItem(MediaItem* parent,const int childIdx); 
     void clear();
     
     //! get Url method
     QStringList getItemChildrenUrls(MediaItem* parent);

     //! filtering method
     bool isUrlFiltered(MediaItem* urlItem);
     bool isPlaylistFiltered(MediaItem* playlistItem);
     QString                      _filterPattern;
     
     //! playing status method
     bool itemIsPlaying(MediaItem * item);
     void setItemIsPlaying(MediaItem * item, bool playing);
     
     MediaItem* getPlayingUrlItem();
     void updatePlayingItem(const QString& url);
     void stopPlayingItem();

     //! Favorites status method
     bool itemIsFavorite(MediaItem * item);
     void setItemIsFavorite(MediaItem * item, bool isfavorite);
     
     //! Broken status method
     void updateBrokenItem(const QString& url);
     
  signals:
    void signalPlayingStatusChanged();
    void signalFavoriteStatusChanged();    
    void modelCleared();

  private:
     MediaItem *           _rootItem;
     MediaItem *           _playingItemIdx;
};

#endif // _PLSFILE_MODEL_H_
