/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _VIRTUAL_PLAYLIST_H_
#define _VIRTUAL_PLAYLIST_H_

#include <QObject>
#include <QStringList>
#include <QList>
#include <QString>
      
      
/*******************************************************************************
    VirtualPlaylist 
*******************************************************************************/
class VirtualPlaylist : public QObject
{
Q_OBJECT
  public: 
    VirtualPlaylist(QWidget *parent=0);
    
    void AppendFileInPlaylist(const QString &file);
    void AppendFilesInPlaylist(const QStringList& list);
    void AppendFilesInPlaylist(const QStringList& list, int startIdx);
    void ClearPlaylist();
    QString GetActiveTrack();
    QString GetNextTrack();
    QString GetPrevTrack();  
    void    StopPlaying();
    bool    isPlaying() {return _isPlaying;}
    bool    _isPlaying; 

    void setRepeatMode(int m) {_repeatMode = (RepeatMode) m;}
    void setShuffleMode(int m) {_shuffleMode = (ShuffleMode) m;}

  private :
    QStringList            _listTrack;
    QList<bool>            _listisPlayed;
    int                    _PlayingIdx;
    
    enum RepeatMode {RepeatOff = 0,RepeatTrack = 1, RepeatAll = 2 };
    RepeatMode        _repeatMode;
    enum ShuffleMode {ShuffleOff = 0 ,ShuffleOn = 1};
    ShuffleMode       _shuffleMode;
    
    void setActiveTrack(int idx);
    QStringList unplayedTrack();
    
  signals :
  void signal_collection_playTrack();
};

#endif // _VIRTUAL_PLAYLIST_H_


