/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _DASHBOARD_SCENE_H_
#define _DASHBOARD_SCENE_H_

#include <QtGui>
#include <QtCore>

class VirtualPlaylist;

/*******************************************************************************
    DashBoardScene
*******************************************************************************/
class DashBoardScene : public QGraphicsScene 
{
Q_OBJECT
  public:
    DashBoardScene(QWidget* parent);
    void setActivate(bool a) {_activated = a;}
    bool isActivated() {return _activated;}
    void populateScene();
    void  setVirtualPlaylist(VirtualPlaylist  *playlist);

  private slots:
    void updateScene();
    void setChartView();
    void setGridView();
    void dashboardDoubleClick();
    
  private:
    void populateMostPlayedAlbum(int YPos);
    void populateMostPlayedAlbumChart(int YPos);
    void populateMostPlayedArtist(int YPos);
    void populateMostPlayedArtistChart(int YPos);
    void playAlbum();
    void playArtist();  
    
  protected:
    void contextMenuEvent(QGraphicsSceneContextMenuEvent *event);
    
  private :
    QWidget                   *_parentWidget;
    bool                      _activated;

    QGraphicsItem               *_mouseGrabbedItem;
    
    bool                      isGridView;
    QAction                   *chartView;
    QAction                   *gridView;

    VirtualPlaylist             *_virtualPlaylist;    
};


#endif // _CONTEXT_SCENE_H_
