/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _DATABASE_MANAGER_H_
#define _DATABASE_MANAGER_H_

#include <QObject>
#include <QString>
#include <QStringList>
#include <QSettings>

namespace DB {
  struct S_dbParam {
      S_dbParam() {
         autoRebuild = false;
         checkCover  = true;
         sourcePathList = QStringList();
      }

      bool           autoRebuild;
      bool           checkCover;
      bool           useGrid;
      QStringList    sourcePathList;
  };
}

/*******************************************************************************
    dbManager
*******************************************************************************/
class DatabaseManager : public QObject
{
Q_OBJECT
  public:
    DatabaseManager();
    void restoreSettings();
    void saveSettings();
    void setGridView(bool b);
    bool isVersionOK();
    
    QString     DB_FILE();
    QString     DB_ID();
    QString     DB_REVISION();
    const DB::S_dbParam&  DB_PARAM();
    
    bool        multiDb;
    QString     DB_NAME;
    QMap<QString, DB::S_dbParam> _dbParamList;
        
  private:
    QSettings  *s;
    
  signals:
    void settingsChanged();
};

#endif // _DATABASE_MANAGER_H_
