/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _FILE_VIEWER_H_
#define _FILE_VIEWER_H_

#include <QListView>
#include <QFileSystemModel>
#include <QMouseEvent>
#include <QWidget>
#include <QLabel>

/*******************************************************************************
    FileViewer
*******************************************************************************/
class FileViewer : public QWidget
{
Q_OBJECT
  public: 
    FileViewer(QWidget *parent);
    void load();
    bool isLoaded() {return _loaded;}
    void setPlace(const QString & place);
  protected:
    void mouseMoveEvent(QMouseEvent *event);
  private :
    void updateCurrentIndex(const QModelIndex &idx);
  private slots:
    void itemActivated(const QModelIndex &index);
    void goPrev();
    void goNext();
    void goUp();

  private :
    QFileSystemModel       *fileSystemModel;
    bool                   _loaded;
    QListView              *listView;
    
    //! browser history
    int                    _currentBrowserIdx;
    QList<QModelIndex>     _browserList;
    QModelIndex            rootIdx;
    QAction                *goPrevA;
    QAction                *goNextA;
    QAction                *goUpA;
    
    QLabel                 *pathString;
};

#endif // _FILE_VIEWER_H_
