/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "mediamimedata.h"
#include "mediaitem.h"

MediaMimeData::MediaMimeData() { }

QStringList MediaMimeData::formats() const 
{
    QStringList formats( QMimeData::formats() );
    formats.append(MEDIA_MIME);
    return formats;
}

bool MediaMimeData::hasFormat( const QString &mimeType ) const 
{
    return mimeType == MEDIA_MIME;
}

void MediaMimeData::addMediaItem(MediaItem *mi) 
{
    _listMediaItem.append(mi);
}

void MediaMimeData::addMediaItemList(QList<MediaItem*> list) 
{
    _listMediaItem.append(list);
}
