/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _MEDIAMIMEDATA_H
#define _MEDIAMIMEDATA_H


#include <QMimeData>

class MediaItem;

const QString MEDIA_MIME = "application/x-yarockplayer-media";



class MediaMimeData : public QMimeData
{
  public:
    MediaMimeData();

    virtual QStringList formats() const;
    
    virtual bool hasFormat( const QString &mimeType ) const;

    QList<MediaItem*> getMediaItem() const { return _listMediaItem; }

    void addMediaItem(MediaItem *mi);

    void addMediaItemList(QList<MediaItem*> list);

  private:
    QList<MediaItem*> _listMediaItem;
};

#endif // _MEDIAMIMEDATA_H
