/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _INFO_RESOLVER_H_
#define _INFO_RESOLVER_H_

#include <QtGui/QPixmap>
#include <QString>
#include <phonon/mediaobject.h>

class Player;
class MediaItem;
enum E_InfoState {PLAYING, STOPPED, ERROR};

/*******************************************************************************
    InfoResolver
*******************************************************************************/
class InfoResolver : public QObject 
{
Q_OBJECT
    static InfoResolver* INSTANCE;

  public:
    InfoResolver(QObject* parent = 0);
    static InfoResolver* instance() { return INSTANCE; }
    
    E_InfoState state() {return _state;} 
    
    MediaItem * mediaItem() {return _mediaItem;}

    const QString& activeUrl() {return _url;}

    const QPixmap& mediaPix() {return _pix;}
  
  private slots:
    void updateSource(QString);
    void stateChanged(Phonon::State, Phonon::State);
    void updateMetaData();
    void sendLastFmLove(); //! 0.0.49
     
  signals:
    void playingInfoChanged();
    void stateChanged();
    void streamInfoChanged();
    void signal_lastFmLove(QString, QString); //! 0.0.49
    
  private:
    Player           *_player;
    E_InfoState      _state;
    
    QString          _url;
    QPixmap          _pix;
    MediaItem*       _mediaItem;
};

#endif // _INFO_RESOLVER_H_
