/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef _PLAYLISTWIDGET_H_
#define _PLAYLISTWIDGET_H_

#include "Playlist/playlistview.h"
#include "Playlist/playlistmodel.h"

#include <QtGui>


class PlaylistWidget : public QWidget
{
  Q_OBJECT
public: 
    PlaylistWidget(QWidget *parent, PlaylistView *playlistview);
    void setPlaylistModel(PlaylistModel *model);
    void saveLastPlaylistMode();
    void restoreLastPlaylistMode();
    
private :
    QMenu            *menuPlaylist;
    QAction          *modeTitleAct;
    QAction          *modeAlbumAct;
    QAction          *modeArtistAct;
  
private :
    PlaylistView     *_playlistview;
    PlaylistDelegate *_playlistdelegate;
    PlaylistModel    *_playlistmodel;
    
    void UpdateViewMode(PLAYQUEUE::Q_MODE mode);
    PLAYQUEUE::Q_MODE     _playlistMode;
    
private slots:
    void updatePlaylistSummary();
    void modeTitleTriggered();
    void modeAlbumTriggered(); 
    void modeArtistTriggered();
};



#endif // _PLAYLISTWIDGET_H_
