/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _SHORTCUT_DIALOG_H_
#define _SHORTCUT_DIALOG_H_

#include <QDialog>
#include <QLabel>
#include <QModelIndex>
#include <QKeySequence>
#include <QKeyEvent>


class ShortcutDialog : public QDialog
{
  Q_OBJECT

  public:
  explicit ShortcutDialog(QModelIndex index, QWidget *parent = 0);

  protected:
    void keyReleaseEvent(QKeyEvent *e);

  private:
    QLabel * currentShortcut;
    QModelIndex     _index;
    QKeySequence    _shortcut;
    QList<Qt::KeyboardModifiers> _modifiers;

   private slots:
     void accept();

   signals:
     void shortcutChanged(QModelIndex index, QKeySequence newshortcut);
};

#endif // _SHORTCUT_DIALOG_H_