/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _COVER_THREAD_
#define _COVER_THREAD_

#include <QtCore>


class CoverTask;

class CoverThread : public QThread
{
Q_OBJECT
 public:
    explicit CoverThread(QObject *parent = 0);
    ~CoverThread();
    void run();
    void checkDatabase();
    
private:
    QList<QStringList> _listParam;
    CoverTask*         _coverTask;

private slots:
    void finish();
    
signals:
    void coverThreadEnd();
};


class CoverTask : public QObject 
{
Q_OBJECT

public:
    CoverTask(QObject *parent);
    void run();
    QList<QStringList> _listParam;

signals:
    void finished();

private slots:
    void processCoverSearch();
};

#endif // _COVER_THREAD_
