/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef _PLAYERTOOLBAR_H_
#define _PLAYERTOOLBAR_H_


#include <Widget/seekslider.h>
#include <phonon/volumeslider.h>

#include <QToolBar>
#include <QLabel>
#include <QMenu>
#include <QVBoxLayout>
#include <QToolButton>



class Player;
class RepeatControl;
class ShuffleControl;
    
class VolumeToolButton : public QToolButton
{
Q_OBJECT
  public:
    VolumeToolButton( QWidget *);
    
  private :
    QMenu        *_volumeMenu;
    
  private slots:
    void volumeMenu();
    void volumeMuteChange(bool b);
    void setAudioMuted();
};


class PlayerToolBar : public QToolBar
{
  Q_OBJECT
  public:
    PlayerToolBar(QWidget *parent);
    void restoreSettings();
    void saveSettings();
    
    void StopTrackTime();  

  private:
    SeekSlider           *seekSlider;
    Player               *_player;
    VolumeToolButton     *_volumeButton;
    RepeatControl        *_repeat;
    ShuffleControl       *_shuffle;    
    
    QMap<QString, QAction*> *actions;
    QLabel *currentTime;
    QLabel *totalTime;     

  private slots:
    void changeTimePosition(qint64);
    void changeTotalTimePosition(qint64);
    
  signals:
    void repeatStateChange(int);
    void shuffleStateChange(int);
};

#endif // _PLAYERTOOLBAR_H_
