/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef _SEARCH_FIELD_H_
#define _SEARCH_FIELD_H_

#include <QtGui>


//! ---------- class SearchField -----------------------------------------------
class SearchField : public QLineEdit
{
Q_OBJECT
  public:
    SearchField(QWidget *parent);
    void setInactiveText(QString text);
    void setEnable(bool e);
    
  protected:
    void resizeEvent(QResizeEvent *);
    void paintEvent(QPaintEvent *event);
    
  private slots:
    void updateCloseButton(const QString &text);
    void clearField();
    
  private:
    QToolButton   *_clearButton;
    QString       _inactiveText;
    
  signals:
    void signalSearchTriggered();
};

#endif // _SEARCH_FIELD_H_
