/* YaRock Player
* Copyright (C) 2010-2011 Sebastien amardeilh (sebastien.amardeilh+yarock@gmail.com)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _GLOBAL_H_
#define _GLOBAL_H_

//! Qt
#include <QString>
#include <QAction>
#include <QMap>
#include <QHash>
#include <QThread>
#include <QNetworkAccessManager>

//! local
#include "Web/networkaccess.h"
#include "Database/databasemanager.h"


namespace GLOBAL 
{
    //! --------------- global actions ----------------------------------------- 
    static QMap<QString, QAction*> *g_actions = 0;

    QMap<QString, QAction*>* globalActions() {
        if (!g_actions)
            g_actions = new QMap<QString, QAction*>;
        return g_actions;
    }
    
    //! --------------- global database Manager -------------------------------- 
    static DatabaseManager* dBMan = 0;

    DatabaseManager* dbManager() {
        if (!dBMan) {
            dBMan = new DatabaseManager();
        }
        return dBMan;
    }    
    
    //! --------------- global network access manager -------------------------- 
    static QNetworkAccessManager *nam = 0;

    QNetworkAccessManager* networkAccessManager() {
        if (!nam) {
            nam = new QNetworkAccessManager();
        }
        return nam;
    }

    //! --------------- global network access ---------------------------------- 
    QHash<QThread*, NetworkAccess *> g_http;

    NetworkAccess* http() {
        // const QString threadName = QThread::currentThread()->objectName();
        if (g_http.contains(QThread::currentThread())) {
            return g_http.value(QThread::currentThread());
        } else {
            // qDebug() << "NetworkAccess for thread" << QThread::currentThread();
            NetworkAccess *http = new NetworkAccess();
            g_http.insert(QThread::currentThread(), http);
            return http;
        }
    }
}

#endif // _GLOBAL_H_
